<?php
namespace DTInternet\DtiPlone2t3\Controller;


/***************************************************************
 *
 *  Copyright notice
 *
 *  (c) 2017 Stefan Bublies <bublies@dt-internet.de>, D&T Internet GmbH
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/
use TYPO3\CMS\Core\Utility\GeneralUtility;

/**
 * HelpController
 */
class Plone2Typo3Controller extends \TYPO3\CMS\Extbase\Mvc\Controller\ActionController
{

    /**
     * plone2typo3Repository
     *
     * @var \DTInternet\DtiPlone2T3\Domain\Repository\Plone2Typo3Repository
     * @inject
     */
    protected $plone2typo3Repository = NULL;

    /**
     * action import
     *
     * @return void
     */
    public function importAction()
    {
      @mkdir($_SERVER['DOCUMENT_ROOT'].'/typo3temp/dti_plone2t3/');
      @mkdir($_SERVER['DOCUMENT_ROOT'].'/typo3temp/dti_plone2t3/images/');
      $this->view->assign('timecode', time());
      switch (($_REQUEST['step'] ? $_REQUEST['step'] : $_REQUEST['tx_dtiseminaris_file_dtiseminarisdtiseminarisfile']['step'])) {
         case 0: // Start
            $this->view->assign('step', '0');
            $oCat =  $GLOBALS['TYPO3_DB']->sql_query('SELECT uid, title FROM sys_category WHERE deleted=0 AND hidden=0');
            $aCat = array();
            while ($aTemp = $oCat->fetch_assoc()) {
              $aCat[] = $aTemp;
            }
            $this->view->assign('categories', $aCat);
            break;
         case 2:
            $this->view->assign('step', '2');
            $aSettings = array(
              'imagepath' => $_REQUEST['imagepath'],
              'startdate' => strtotime($_REQUEST['startdate']),
              'enddate' => strtotime($_REQUEST['enddate']),
              'sysfolder' => $_REQUEST['sysfolder'],
              'topnews' => $_REQUEST['topnews'],
              'categories' => implode(',', $_REQUEST['categories']),
            );
           if ($aSettings['imagepath']=='' || intval($aSettings['sysfolder'])==0 || $aSettings['categories']=='') $this->view->assign('step', '-2');
           $rVerzeichnis = opendir($_SERVER['DOCUMENT_ROOT'].'/typo3temp/dti_plone2t3');
           $aArtikelliste = array();
           while ($sDatei=readdir($rVerzeichnis)) {
             if ($sInhalt = @file_get_contents($_SERVER['DOCUMENT_ROOT'].'/typo3temp/dti_plone2t3/'.$sDatei)) {
                $oPloneImport = json_decode($sInhalt);
                foreach ($oPloneImport->items as $oArtikel) {
                  if (strtotime($oArtikel->created)>$aSettings['startdate'] && strtotime($oArtikel->created)<$aSettings['enddate']) {
                    $aArtikel = array(
                      'datei' => $sDatei,
                    );
                    foreach(array('brkreport_text', 'imagetext1', 'imagetext2', 'imagetext3', 'uid', 'parent_id', 'title', 'brkreport_image1', 'brkreport_image2',
                                  'brkreport_image3', 'created', 'modified', 'parent_uid', 'url', 'author', 'review_state') as $sFeld) {
                      $aArtikel[$sFeld] = trim($oArtikel->$sFeld);
                    }
                    $aArtikelliste[] = $aArtikel;
                  }
                }
             }
           }
           $this->view->assign('server', $_SERVER['SERVER_NAME']);
           $this->view->assign('artikelliste', $aArtikelliste);
           $this->view->assign('settings', $aSettings);
           break;
        case 3:
           $oArtikel = $GLOBALS['TYPO3_DB']->sql_query('SELECT uid, tx_dtiplone2t3uid, tx_dtiplone2t3oldpath FROM tx_news_domain_model_news WHERE  tx_dtiplone2t3oldpath!=""');
           $sImagePathNeu = 'Eigene_Bilder_und_Videos/'.($_REQUEST['imagepath'] ? $_REQUEST['imagepath'] : 'bilder_aus_plone').'/';
           $sImagePathNeu = str_replace('//', '/', $sImagePathNeu);
           $sImagePath =  $_SERVER['DOCUMENT_ROOT'].'/typo3temp/dti_plone2t3/images/';
           $sImagePath = str_replace('//', '/', $sImagePath);
           @mkdir($_SERVER['DOCUMENT_ROOT'].'/fileadmin/'.$sImagePathNeu);
           while ($aArtikel = $oArtikel->fetch_assoc()) {
             if (trim($aArtikel['tx_dtiplone2t3oldpath'])=='') continue;
             $rVerzeichnis = opendir($sImagePath);
             $i=0;
             while ($sDatei = readdir($rVerzeichnis)) {
               if (substr($sDatei, 0, strlen($aArtikel['tx_dtiplone2t3oldpath']))==$aArtikel['tx_dtiplone2t3oldpath'] && substr($sDatei,-4)!='.txt') {
                 $sBildunterschrift = '';
                 $i++;
                 $storageRepository = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('TYPO3\\CMS\\Core\\Resource\\StorageRepository');
                 $storage = $storageRepository->findByUid(1);
                 if (!file_exists($_SERVER['DOCUMENT_ROOT'].'/fileadmin/'.$sImagePathNeu.$sDatei)) {
                   $storage->addFile($sImagePath.$sDatei, $storage->getFolder($sImagePathNeu), $sDatei);
                   $sBildunterschrift = @file_get_contents($sImagePath.$sDatei.'.txt');
                   $sBildunterschrift = str_replace('"', '&quot;', $sBildunterschrift);
                   $oBild = $GLOBALS['TYPO3_DB']->sql_query('SELECT uid FROM sys_file WHERE identifier="/'.$sImagePathNeu.$sDatei.'"');
                   if ($aBild = $oBild->fetch_assoc()) {
                     $sSql = 'INSERT INTO sys_file_reference SET pid='.intval($_REQUEST['sysfolder']).', cruser_id=70, crdate='.time().', tstamp='.time().',
                                          uid_local='.$aBild['uid'].', uid_foreign='.$aArtikel['uid'].', tablenames="tx_news_domain_model_news", 
                                          fieldname="fal_media", sorting_foreign='.$i.', table_local="sys_file", showinpreview=1, description="'.$sBildunterschrift.'"';
                     $GLOBALS['TYPO3_DB']->sql_query($sSql);
                   }
                 }
               }
             }
             
           }
           $this->view->assign('step', 3);
      }
    }

    protected function saveAction()
    {

    }
}
